/*
-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : INCIO - 12/01/2012                                      --
-- PROGRAMADOR     : WILLIAM AZEVEDO DE PAULA                                 --
-- OBJETIVOS       : - GERAO DO MAPA DA PRODUO                            --
--                                                                            --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--  As Excesses encontram-se no formato:                                     --
--    '?'||Mensagem(12 caracteres)||Objeto com Erro || ''                    --
-- ========================================================================== --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\2961_MACSTPO_GERA_MAPA_PROD.sql
-- ========================================================================== --
*/

create or replace
PROCEDURE GERA_MAPA_PROD(
     P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE, 
     P_LISTACIA      IN VARCHAR2,   --Lista de CIAS. Formato: '_CDCIA1_CDCIA2_CDCIA3_'  
     P_LISTAPROGSERV IN VARCHAR2,   --Lista de Prog. Servico. formato: '_CDCIA1||NRPROGSERV1_CDCIA1||NRPROGSERV2_CDCIA2||NRPROGSERV1_ 
     P_TNRPROGSERV   IN VARCHAR2,
     P_TNRCDCIA      IN VARCHAR2,
     P_MAPASGERADOS  OUT VARCHAR2,   --Concatenao de todos os Mapas Gerados. Retornado ao final da execuo
     P_NRLOGMAPAPROD OUT VARCHAR2    --Chave do log da gerao atual
) AS
     /*==========================================
          Declarao das variveis
     ==========================================*/
     V_DATA_ATUAL      DATE; 
     V_DATAHORA_ATUAL  DATE;
     V_DTHRINIPROD     DATE;
     V_HORA_ATUAL      VARCHAR2(5);
     V_NRMAPAPROD      MAPAPROD.NRMAPAPROD%TYPE;
     V_CDORDEMMAPAPROD VARCHAR2(10);     
     V_CONTA1          INTEGER;
     V_CONTA2          INTEGER;
     V_CONTA3          INTEGER;
     V_QTSERV          INTEGER; 
    
     V_QTPRODREC       FLOAT;
     V_VRLOADPRODREC   FLOAT;
     V_ORIGEM          VARCHAR(2);     
     V_CDFILIAL        FILIAL.CDFILIAL%TYPE;
     V_CDCIA           COMPANHIA.CDCIA%TYPE;
     V_CIA_ANT         COMPANHIA.CDCIA%TYPE;
     V_CDSERVICO       SERVCLASSEPROG.NRPROGSERV%TYPE;  
     V_CDPRODREC       PRODUTO.CDPRODUTO%TYPE;
     V_CDCLASSE        CLASSE.CDCLASSE%TYPE;
     V_SGCLASSE        CLASSE.SGCLASSE%TYPE;
     V_CDCICLO         CICLO.CDCICLO%TYPE;
     V_IDCICLO         CICLO.IDCICLO%TYPE;
     V_SGUNIDADE       UNIDMEDIDA.SGUNIDADE%TYPE;
     V_SGUNIDADESG     UNIDMEDIDA.SGUNIDADE%TYPE;
     V_SGUNIDPRODREC   UNIDMEDIDA.SGUNIDADE%TYPE;
     V_CDSETOR         SETOR.CDSETOR%TYPE;
     V_CDSETORSERV     SETOR.CDSETOR%TYPE;
     V_SGSETOR         SETOR.SGSETOR%TYPE;
     V_CDSETORPRODREC  SETOR.CDSETOR%TYPE;
     V_SGSETORPRODREC  SETOR.SGSETOR%TYPE;
     V_DTPRODUCAO      VOOSPROGSERV.DTPRODUCAO%TYPE;
     V_DATAPROD_ANT    VOOSPROGSERV.DTPRODUCAO%TYPE;
     V_NRTURNOPROD     VOOSPROGSERV.NRTURNOPROD%TYPE;    
     V_TURNOPROD_ANT   VOOSPROGSERV.NRTURNOPROD%TYPE; 
     V_CDMANCIA        MANUALCIA.CDMANCIA%TYPE;
     V_CDARVSERVICO    PRODUTO.CDARVPROD%TYPE;
     V_DSSERVICO       VARCHAR2(1000);
     V_SGCIA           COMPANHIA.SGCIA%TYPE;
     V_NMCIA           COMPANHIA.NMCIA%TYPE;
     V_NRVOO           VOO.NRVOO%TYPE;
     V_CDTRECHO        VOOTRECHO.CDTRECHO%TYPE;
     V_DTDECOLVOO      VOOSPROGSERV.DTDECOLVOO%TYPE;
     V_QTTORPRODSERV   SERVCLASSEPROG.QTTORPRODSERV%TYPE;
     V_CDESPEPROD      ESPEPROD.CDESPEPROD%TYPE;
     V_CDSUBGRU        SUBGRUSEMA.CDSUBGRU%TYPE;
     V_ARVSUBGRU       PRODUTO.CDARVPROD%TYPE; 
     V_ARVPRODREC      PRODUTO.CDARVPROD%TYPE;
     V_DSSUBGRU        VARCHAR2(200);
     V_VRPELOADSUBGRU  SUBGRUSEMA.VRPELOADSUMA%TYPE;
     V_TXCOMSUMASUBGRU SUBGRUSEMA.TXCOMSUMA%TYPE;
     V_TXCOPRODREC     SUBGRUSEMA.TXCOMSUMA%TYPE;
     V_VRCUSTPRODMMSG  COMPPROD.VRCUSTPRODMM%TYPE;
     V_VRCUSTEQUIMMSG  COMPPROD.VRCUSTEQUIMM%TYPE;
     V_VRCUSTRDELMMSG  COMPPROD.VRCUSTRDELMM%TYPE;  
     V_NMPRODREC       PRODUTO.NMPRODUTO%TYPE;
     V_HRDECOLVOO      VOOTRECHO.HRDECOLVOO%TYPE;
     V_NRPROGSERV      PROGSERVICO.NRPROGSERV%TYPE;
     V_NRPROGSERV_ANT  PROGSERVICO.NRPROGSERV%TYPE;
     
     /*==========================================
          Declarao dos Cursores
     ==========================================*/
    
    
     
    --Cursor para armazenar todos os Servios presentes nas programaes
     CURSOR C_SERVICOS_MAPA IS
     SELECT DISTINCT
          PS.CDFILIAL,PS.CDCIA,CIA.SGCIA,CIA.NMCIA,SCP.CDSERVICO,
          PR.CDARVPROD || ' ' || PR.NMPRODUTO||' - '||CL.SGCLASSE||' - '||CI.IDCICLO AS DSSERVICO,
          CVP.CDCLASSE,CL.SGCLASSE, SCP.CDCICLO,CI.IDCICLO,PR.SGUNIDADE,
          SR.CDSETOR,SR.SGSETOR,VPS.DTPRODUCAO,VPS.NRTURNOPROD,PS.NRPROGSERV
       FROM SERVCLASSEPROG SCP,CLASVOOPROGSERV CVP,VOOSPROGSERV VPS,PROGSERVICO PS,PRODUTO PR,CLASSE CL,CICLO CI,
          SETOR SR,COMPANHIA CIA 
      WHERE
        (SCP.CDCIA    = CVP.CDCIA ) AND
        (SCP.CDCIA    = VPS.CDCIA ) AND
        (SCP.CDCIA    = PS.CDCIA  ) AND
        (SCP.CDFILIAL = CVP.CDFILIAL) AND
        (SCP.CDFILIAL = VPS.CDFILIAL) AND
        (SCP.CDFILIAL = PS.CDFILIAL) AND
        (SCP.NRPROGSERV = CVP.NRPROGSERV) AND
        (SCP.NRPROGSERV = VPS.NRPROGSERV) AND
        (SCP.NRPROGSERV = PS.NRPROGSERV ) AND
        (SCP.CDCLASSE   = CVP.CDCLASSE  ) AND
        (SCP.NRVOO      = CVP.NRVOO     ) AND
        (SCP.NRVOO      = VPS.NRVOO     ) AND
        (SCP.DTDECOLVOO = CVP.DTDECOLVOO) AND
        (SCP.DTDECOLVOO = VPS.DTDECOLVOO) AND
        (SCP.CDTRECHO   = CVP.CDTRECHO  ) AND
        (SCP.CDTRECHO   = VPS.CDTRECHO  ) AND
        (PS.CDFILIAL    = P_CDFILIAL    ) AND --Parmetro de Entrada
        (SCP.CDSERVICO  = PR.CDPRODUTO  ) AND
        (SCP.CDCICLO    = CI.CDCICLO    ) AND
        (CVP.CDCLASSE   = CL.CDCLASSE   ) AND
        (CVP.CDCLASSE   = PR.CDCLASSE   ) AND   
        (SR.CDSETOR(+)  = PR.CDSETOR    ) AND   
        (CIA.CDCIA      = PS.CDCIA      ) AND
        ((P_TNRPROGSERV  = 'T')OR(INSTR(P_LISTAPROGSERV,PS.CDCIA||'-'||PS.NRPROGSERV)>0)) AND --Parmetros de Entrada
        ((P_TNRCDCIA       = 'T')OR(INSTR(P_LISTACIA,PS.CDCIA) > 0)) AND  --Parmetros de Entrada 
        (PS.IDSITPROGSERV = 'P') 
      ORDER BY
        PS.CDFILIAL,PS.CDCIA,VPS.DTPRODUCAO,VPS.NRTURNOPROD,PS.NRPROGSERV, SCP.CDSERVICO;
        
        
      --Cursor para armazenar as informaes do servio de acordo com o manual mais recente
      CURSOR C_CONFIG_SERV_MANUAL IS
        SELECT 
           EP.CDCIA, EP.CDMANCIA, PR.CDPRODUTO CDSERVICO,PR.CDARVPROD,PR.CDCLASSE, PR.CDCICLO,
           PR.SGUNIDADE, CL.SGCLASSE, CC.IDCICLO,PR.CDSETOR, SR.SGSETOR,
           /* PR.IDPRODATIVPR,*/ EP.CDFILIAL,
           PR.CDARVPROD || ' ' || PR.NMPRODUTO||' - '||CL.SGCLASSE||' - '||CC.IDCICLO AS DSSERVICO
        FROM SETOR SR, PRODUTO PR, CLASSE CL, ESPEPROD EP, CICLO CC
        WHERE (EP.CDFILIAL      = V_CDFILIAL   ) AND
              (EP.CDCIA         = V_CDCIA      ) AND      
              (EP.IDTPMANUAL    = 'M'          ) AND
              (EP.CDPRODUTO     = PR.CDPRODUTO ) AND
              (CC.CDCICLO       = PR.CDCICLO   ) AND
              (CL.CDCLASSE      = PR.CDCLASSE  ) AND
              (PR.IDPRODCOMISS  = '1'          ) AND
              (SR.CDSETOR(+)    = PR.CDSETOR   ) AND
              (PR.CDPRODUTO     = V_CDSERVICO  ) AND
              (EP.CDMANCIA      = (SELECT CDMANCIA 
                                   FROM MANUALCIA 
                                   WHERE 
                                      (CDCIA     = EP.CDCIA    ) AND
                                      (CDFILIAL  = EP.CDFILIAL ) AND
                                      (DTINIVGMA = (SELECT MAX(DTINIVGMA)
                                                     FROM MANUALCIA
                                                     WHERE
                                                      (CDCIA = EP.CDCIA     )AND
                                                      (CDFILIAL = EP.CDFILIAL) AND
                                                      (DTINIVGMA < SYSDATE  ) 
                                                 
                                                   )
                                 
                                       ) AND
                                       (IDTPMANUAL = 'M'     )
                                  
                                  )   
              ); 
              
      --Cursor para armazenar os Voos que utilizam o servio em determinada data
      CURSOR C_VOOS_SERVICO IS
      SELECT DISTINCT SCP.CDSERVICO,SCP.NRVOO,SCP.CDTRECHO,SCP.DTDECOLVOO,VPS.NRTURNOPROD,
               VPS.DTPRODUCAO,SCP.QTTORPRODSERV, VPS.CDCIA
        FROM SERVCLASSEPROG SCP, VOOSPROGSERV VPS, CLASVOOPROGSERV CVP
        
        WHERE   
           (VPS.CDFILIAL    = CVP.CDFILIAL  ) AND
           (VPS.CDFILIAL    = SCP.CDFILIAL  ) AND
           (VPS.CDCIA       = SCP.CDCIA     ) AND
           (VPS.CDCIA       = CVP.CDCIA     ) AND
           (VPS.NRVOO       = CVP.NRVOO     ) AND
           (VPS.NRVOO       = SCP.NRVOO     ) AND
           (VPS.CDTRECHO    = CVP.CDTRECHO  ) AND
           (VPS.CDTRECHO    = SCP.CDTRECHO  ) AND
           (VPS.DTDECOLVOO  = CVP.DTDECOLVOO) AND
           (VPS.DTDECOLVOO  = SCP.DTDECOLVOO) AND
           (SCP.CDCLASSE    = CVP.CDCLASSE  ) AND
           (VPS.CDFILIAL    = V_CDFILIAL    ) AND
           (VPS.CDCIA       = V_CDCIA       ) AND
           (SCP.CDSERVICO   = V_CDSERVICO   ) AND
           (VPS.DTPRODUCAO  = V_DTPRODUCAO  ) AND
           (VPS.NRTURNOPROD = V_NRTURNOPROD ) AND
           (SCP.NRPROGSERV  = V_NRPROGSERV) AND
           ((INSTR(P_LISTAPROGSERV,VPS.CDCIA||'-'||VPS.NRPROGSERV) > 0) OR (P_TNRPROGSERV = 'T'));
       
              
      --Cursor para armazenar os SubGrupos de um Servio
      CURSOR C_SUBGRU_MAPA IS
      SELECT DISTINCT
         SU.CDFILIAL,SU.CDCIA,SU.CDSERVICO,SU.CDCLASSE , SU.CDCICLO,SU.CDSUBGRU,PR.CDARVPROD,
         PR.NMPRODUTO AS DSSUBGRU, NVL(SR.CDSETOR,V_CDSETORSERV) AS CDSETORRES ,SR.SGSETOR AS SGSETORRES, 
         SU.VRPELOADSUMA, SU.TXCOMSUMA,
         NVL(CP.VRCUSTPRODMM,0) VRCUSTPRODMM, NVL(CP.VRCUSTEQUIMM,0) VRCUSTEQUIMM,
         NVL(CP.VRCUSTRDELMM,0) VRCUSTRDELMM,PR.SGUNIDADE
      FROM
         SUBGRUSEMA SU, SUBGRUPO SG, SETOR SR, PRODUTO PR, ESPEPROD EP,COMPPROD CP
      WHERE
         (SU.CDCIA        =  V_CDCIA       ) AND
         (SU.CDFILIAL     =  V_CDFILIAL    ) AND
         (SU.CDMANCIA     =  V_CDMANCIA    ) AND
         (SU.CDSERVICO    =  V_CDSERVICO   ) AND
         (SU.CDCLASSE     =  V_CDCLASSE    ) AND
         (SU.CDCICLO      =  V_CDCICLO     ) AND
         (SU.CDSUBGRU     = SG.CDSUBGRU    ) AND
         (SG.CDSUBGRU     = PR.CDPRODUTO   ) AND         
         (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
         (CP.CDPRODUTO    = SU.CDSERVICO   ) AND
         (CP.CDPRODINSUMO = SU.CDSUBGRU    ) AND
         (EP.IDTPMANUAL   = 'M'            ) AND
         (EP.CDFILIAL     = SU.CDFILIAL    ) AND
         (EP.CDCIA        = SU.CDCIA       ) AND
         (EP.CDMANCIA     = SU.CDMANCIA    ) AND
         (SU.CDSERVICO    = EP.CDPRODUTO   ) AND
         (NVL(PR.CDSETOR,V_CDSETORSERV)      = SR.CDSETOR (+)); 
      
      --Cursor para buscar os Produtos e Receitas que compem o Sub Grupo
      CURSOR C_PRODREC_SUBGRU IS
      SELECT DISTINCT PR.CDSERVICO,PR.CDSUBGRU,PR.ORIGEM,
       PR.CDPRODUTO,PR.QTPRODSUMA,PR.TXCOPRODSUMA,
       PR.SGUNIDADE,PR.VRLOADPSUMA,
       PR.NMPRODUTO,PR.CDSETOR AS CDSETORRES,SR.SGSETOR AS SGSETORRES,
       PR.CODIGO
       FROM SETOR SR,
           (SELECT PS.CDSERVICO,PS.CDSUBGRU,PS.CDPRODUTO,
                   PS.QTPRODSUMA,PS.TXCOPRODSUMA,PS.SGUNIDADE,
                   PS.VRLOADPSUMA,
                   NVL(CDSETOR,V_CDSETOR) AS CDSETOR,PT.NMPRODUTO,'P' AS ORIGEM,
                   PT.CDARVPROD CODIGO
            FROM PRODSUBSEMA PS, PRODUTO PT
            WHERE (PS.CDCIA     = V_CDCIA      ) AND
                  (PS.CDFILIAL  = V_CDFILIAL   ) AND
                  (PS.CDMANCIA  = V_CDMANCIA   ) AND
                  (PS.CDSERVICO = V_CDSERVICO  ) AND
                  (PS.CDSUBGRU  = V_CDSUBGRU   ) AND
                  (PS.CDCLASSE  = V_CDCLASSE   ) AND
                  (PS.CDCICLO   = V_CDCICLO    ) AND
                  (PS.CDPRODUTO = PT.CDPRODUTO)
            UNION ALL
            SELECT RS.CDSERVICO,RS.CDSUBGRU,RE.CDRECEITA,
                   RS.QTRECSUMA,RS.TXCOMRECSUMA,RS.SGUNIDADE,
                   RS.VRLOADRSUMA,NVL(RE.CDSETOR,V_CDSETOR) AS CDSETOR,
                   RE.DSRECEITA,'R' AS ORIGEM,
                   RE.CDARVREC CODIGO
            FROM RECSUBSEMA RS, RECEITA RE
            WHERE (RE.CDRECEITA = RS.CDRECEITA) AND
                  (RS.CDCIA     = V_CDCIA      ) AND
                  (RS.CDFILIAL  = V_CDFILIAL   ) AND
                  (RS.CDMANCIA  = V_CDMANCIA   ) AND
                  (RS.CDSERVICO = V_CDSERVICO  ) AND
                  (RS.CDCLASSE  = V_CDCLASSE   ) AND
                  (RS.CDCICLO   = V_CDCICLO    ) AND
                  (RS.CDSUBGRU  = V_CDSUBGRU   )) PR
      WHERE (SR.CDSETOR(+) = PR.CDSETOR)
      ORDER BY ORIGEM,CODIGO;
       
BEGIN

    --Buscar a Data e hora Atual
    SELECT TO_DATE(TO_CHAR(SYSDATE,'DD/MM/YYYY')),TO_CHAR(SYSDATE,'HH24:MI'),SYSDATE
    INTO V_DATA_ATUAL,V_HORA_ATUAL,V_DATAHORA_ATUAL 
    FROM DUAL;
    
    P_MAPASGERADOS := '';
    
    V_CIA_ANT       := NULL;
    V_TURNOPROD_ANT := NULL;
    V_DATAPROD_ANT  := NULL;
    V_NRPROGSERV_ANT := NULL;
    
    /*Prepara o log do mapa de produo*/
    NOVO_CODIGO_SC('LOGMAPAPROD', P_NRLOGMAPAPROD);
    
    --Busca todos os Servios das Programaes passadas por parmetro, agrupados por filial,CIA,Data ad Produo e Turno
    OPEN C_SERVICOS_MAPA;       
    LOOP       
       --Percorre todos os Servios
       FETCH C_SERVICOS_MAPA INTO V_CDFILIAL,V_CDCIA,V_SGCIA,V_NMCIA,V_CDSERVICO, V_DSSERVICO, V_CDCLASSE,
                                  V_SGCLASSE,V_CDCICLO,V_IDCICLO,V_SGUNIDADE,V_CDSETOR,V_SGSETOR,
                                  V_DTPRODUCAO,V_NRTURNOPROD,V_NRPROGSERV;
       EXIT WHEN C_SERVICOS_MAPA%NOTFOUND;


       --Verifica se algum dos servios pertencem a vos sem parametrizao (data e turno da produo)
       IF ((V_DTPRODUCAO IS NULL) OR (V_NRTURNOPROD IS NULL)) THEN 
            --RAISE_APPLICATION_ERROR( -20502, '?VoosSemParam'||V_SGCIA||'-'||V_NMCIA||'', false);   
            /*Gerao interrompida. Existem vos sem parametrizao para gerao do Mapa de Produo para
              a Companhia ||V_SGCIA||'-'||V_NMCIA.*/
              
            INSERT INTO LOGMAPAPROD
            (NRLOGMAPAPROD, CDSERVICO, DSSERVICO, CDCIA, DSCOMPANHIA, DTPRODUCAO, NRPROGSERV, DSERRO)
            VALUES
            (P_NRLOGMAPAPROD,V_CDSERVICO, V_DSSERVICO, V_CDCIA, V_SGCIA || ' - ' || V_NMCIA,
             V_DTPRODUCAO, V_NRPROGSERV,  'VOOSEMPARAM');
            
            CONTINUE;
       END IF;
      
       --Se a CIA, o turno ou a data da Produo mudar, gera um novo sequencial para o mapa
       IF (V_DTPRODUCAO <> V_DATAPROD_ANT) OR (V_NRTURNOPROD <> V_TURNOPROD_ANT)OR (V_CDCIA <> V_CIA_ANT)OR
          (V_NRPROGSERV_ANT <> V_NRPROGSERV) OR 
          ((V_DATAPROD_ANT IS NULL)AND(V_TURNOPROD_ANT IS NULL)AND(V_CIA_ANT IS NULL) AND (V_NRPROGSERV_ANT IS NULL)) THEN
       
          V_DATAPROD_ANT   := V_DTPRODUCAO;
          V_TURNOPROD_ANT  := V_NRTURNOPROD;
          V_CIA_ANT        := V_CDCIA;
          V_NRPROGSERV_ANT := V_NRPROGSERV;
          
          --Verifica se h tempo suficiente para a produo
          BEGIN
             SELECT TO_DATE(TO_CHAR(V_DTPRODUCAO,'DD/MM/YYYY')||SUBSTR(HRINITURNO,1,2)||':'||SUBSTR(HRINITURNO,3,2),'DD/MM/YYYY HH24:MI')
             INTO V_DTHRINIPROD 
             FROM TURNO 
             WHERE NRTURNO = V_NRTURNOPROD;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_DTHRINIPROD := NULL;
          END;
          
          /*IF (V_DTHRINIPROD < V_DATAHORA_ATUAL) THEN 
              
              SELECT CDARVPROD,NMPRODUTO 
              INTO V_CDARVSERVICO,V_DSSERVICO 
              FROM PRODUTO 
              WHERE CDPRODUTO = V_CDSERVICO;  
              
             --RAISE_APPLICATION_ERROR( -20502, '?SrvSemTmpPrd'||V_SGCIA||'-'||V_CDARVSERVICO||'-'||V_DSSERVICO||'', false);  
               /* Gerao Interrompida. No h tempo suficiente para a produo do servio V_CDARVSERVICO||'-'||V_DSSERVICO */
          --END IF;          
          
                    
          --==========================GERAR NOVO MAPA DE PRODUO==============================================================
          
          --proximo Codigo do Mapa. Formato:  Sequencial/Ms/Ano. Cada Numero de Mapa corresponde a um dia da produo
          SELECT LPAD((NVL(MAX(SUBSTR(NRMAPAPROD,1,4)),0)+1),4,0)||'-'||TO_CHAR(V_DTPRODUCAO,'MM')||'/'||TO_CHAR(V_DTPRODUCAO,'YYYY')
          INTO V_NRMAPAPROD
          FROM
             MAPAPROD
          WHERE
             (CDFILIAL = P_CDFILIAL) AND
             (TO_CHAR(DTMAPAPROD,'MM') = TO_CHAR(V_DTPRODUCAO,'MM')) AND
             (TO_CHAR(DTMAPAPROD,'YYYY') = TO_CHAR(V_DTPRODUCAO,'YYYY'));
             
         --cdigo de ordenao do mapa (ordem de gerao)
         SELECT LPAD(NVL(MAX(CDORDEMMAPAPROD),0)+1,10,0)
          INTO  V_CDORDEMMAPAPROD
          FROM
             MAPAPROD
          WHERE
             (CDFILIAL = P_CDFILIAL) AND
             (TO_CHAR(DTMAPAPROD,'MM') = TO_CHAR(V_DTPRODUCAO,'MM')) AND
             (TO_CHAR(DTMAPAPROD,'YYYY') = TO_CHAR(V_DTPRODUCAO,'YYYY'));
                              
         --Salvar as Informaes do Novo Mapa na tabela "MAPAPROD'  
         INSERT INTO MAPAPROD 
            (CDFILIAL,CDCIA,NRMAPAPROD,DTMAPAPROD,NRTURNOMAPAPROD,IDSITMAPAPROD,DTGERMAPAPROD,NRPROGSERV,CDORDEMMAPAPROD)
         VALUES
            (P_CDFILIAL,V_CDCIA,V_NRMAPAPROD,V_DTPRODUCAO,V_NRTURNOPROD,'P',V_DATA_ATUAL,V_NRPROGSERV,V_CDORDEMMAPAPROD);
            
         P_MAPASGERADOS := P_MAPASGERADOS||'-'||V_NRMAPAPROD;
         --=====================================================================================================================
         
       END IF;
       --buscar as configuraes do servio de acordo com o manual da produo vigente
       
       V_CONTA1 := 0;
       OPEN C_CONFIG_SERV_MANUAL;        
       LOOP
          FETCH C_CONFIG_SERV_MANUAL INTO V_CDCIA,V_CDMANCIA,V_CDSERVICO,V_CDARVSERVICO,V_CDCLASSE,V_CDCICLO,V_SGUNIDADE,
                                          V_SGCLASSE,V_IDCICLO,V_CDSETORSERV, V_SGSETOR,V_CDFILIAL,V_DSSERVICO;                                                            
          EXIT WHEN C_CONFIG_SERV_MANUAL%NOTFOUND;
          
          V_CONTA1 := V_CONTA1 + 1;--Conta quantas vezes entrou no LOOP
          
              
              /*IF V_CDSETORSERV IS NULL THEN
                 --RAISE_APPLICATION_ERROR( -20502, '?ServSemSetor'||V_SGCIA||'-'||V_CDARVSERVICO||'-'||V_DSSERVICO||'', false);  
                /*  Gerao Interrompida. O Servico ||V_CDARVSERVICO||'-'||V_DSSERVICO|| no possui setor responsvel cadastrado.
                    Favor Verifique a opo "Manual Aprovado -> Manual da Produo" e tente novamente. 
                INSERT INTO LOGMAPAPROD
               (NRLOGMAPAPROD, CDSERVICO, DSSERVICO, CDCIA, DSCOMPANHIA, DTPRODUCAO, NRPROGSERV, DSERRO)
               VALUES
               (P_NRLOGMAPAPROD, V_CDSERVICO, V_DSSERVICO, V_CDCIA, V_SGCIA || ' - ' || V_NMCIA,
                V_DTPRODUCAO, V_NRPROGSERV, 'SERVSEMSETOR');
                 CONTINUE;
              END IF;*/
              
             --==============================INSERIR O SERVIO NO MAPA===================================================
              INSERT INTO SERVMAPA
                (CDFILIAL,CDCIA,NRMAPAPROD,CDSERVICO,CDSETORRESP,CDCLASSE,CDCICLO,SGUNIDADE)
              VALUES 
                (V_CDFILIAL,V_CDCIA,V_NRMAPAPROD,V_CDSERVICO,V_CDSETOR,V_CDCLASSE,V_CDCICLO,V_SGUNIDADE);                   
             --==========================================================================================================
             
             
             V_QTSERV := 0;
             --busca os vos que usam o servio
             OPEN C_VOOS_SERVICO;
             LOOP
                FETCH C_VOOS_SERVICO INTO V_CDSERVICO,V_NRVOO,V_CDTRECHO,V_DTDECOLVOO,V_NRTURNOPROD,
                                          V_DTPRODUCAO,V_QTTORPRODSERV,V_CDCIA;
                EXIT WHEN C_VOOS_SERVICO%NOTFOUND;
                
                --Buscar horrio de decolagem do Vo
                
                V_HRDECOLVOO := '';                
                BEGIN
                   SELECT HRDECOLVOO INTO V_HRDECOLVOO
                   FROM VOOTRECHO VT
                   WHERE
                      (CDFILIAL = V_CDFILIAL    ) AND
                      (CDCIA    = V_CDCIA       ) AND
                      (NRVOO    = V_NRVOO       ) AND
                      (CDTRECHO = V_CDTRECHO    );                   
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_HRDECOLVOO := '';   
                END;
                   
                --==============================INSERIR OS VOOS NO MAPA PARA O SERVIO====================================
                  INSERT INTO VOOSERVMAPA 
                     (CDFILIAL,NRMAPAPROD,CDSERVICO,CDCIA,NRVOO,CDTRECHO,DTDECOLVOO,HRDECOLVOO,QTTORPRODSERV)
                  VALUES
                     (V_CDFILIAL,V_NRMAPAPROD,V_CDSERVICO,V_CDCIA,V_NRVOO,V_CDTRECHO,V_DTDECOLVOO,V_HRDECOLVOO,V_QTTORPRODSERV);
                --========================================================================================================
                V_QTSERV := V_QTSERV + V_QTTORPRODSERV; --Quantidade total do servio utilizada
             
             END LOOP;--Fim do Loop de Voos
             CLOSE C_VOOS_SERVICO;
             
             --Busca os SubGrupos do servio
             V_CONTA2 := 0;
             
          --   V_CDSETORORI := V_CDSETOR; --guarda o setor do servio de origem
             OPEN C_SUBGRU_MAPA;
             LOOP
                FETCH C_SUBGRU_MAPA INTO V_CDFILIAL,V_CDCIA,V_CDSERVICO,V_CDCLASSE ,V_CDCICLO,V_CDSUBGRU,V_ARVSUBGRU,
                                         V_DSSUBGRU,V_CDSETOR,V_SGSETOR,V_VRPELOADSUBGRU,V_TXCOMSUMASUBGRU,
                                         V_VRCUSTPRODMMSG,V_VRCUSTEQUIMMSG,V_VRCUSTRDELMMSG,V_SGUNIDADESG; 
                EXIT WHEN C_SUBGRU_MAPA%NOTFOUND;
                
                V_CONTA2 := V_CONTA2 + 1; --Conta quantas vezes entrou no Loop de Subgrupo
                
                --=========================INSERIR O SUBGRUPO NO MAPA PARA O SERVIO========================================
                  INSERT INTO SUBGRUSERVMAPA
                    (CDFILIAL,NRMAPAPROD,CDSERVICO,CDCIA,CDSUBGRU,CDSETORRESP,VRPELOAD,TXCONSUMA,VRCUSTPRODMM,
                     VRCUSTEQUIMM,VRCUSTRDELMM,SGUNIDADE)
                  VALUES
                    (V_CDFILIAL,V_NRMAPAPROD,V_CDSERVICO,V_CDCIA,V_CDSUBGRU,V_CDSETOR,V_VRPELOADSUBGRU,V_TXCOMSUMASUBGRU,
                     V_VRCUSTPRODMMSG,V_VRCUSTEQUIMMSG,V_VRCUSTRDELMMSG,V_SGUNIDADESG);
                --==========================================================================================================
                
                V_CONTA3 := 0;                
                OPEN C_PRODREC_SUBGRU;
                LOOP
                   FETCH C_PRODREC_SUBGRU INTO V_CDSERVICO,V_CDSUBGRU,V_ORIGEM,V_CDPRODREC,V_QTPRODREC,V_TXCOPRODREC,
                                               V_SGUNIDPRODREC,V_VRLOADPRODREC,V_NMPRODREC,V_CDSETORPRODREC,V_SGSETORPRODREC, 
                                               V_ARVPRODREC;
                   EXIT WHEN C_PRODREC_SUBGRU%NOTFOUND;
                   
                   V_CONTA3 := V_CONTA3 + 1;
                   
                   --=================INSERIR OS PRODUTOS/RECEITAS DO SUBGRUPO NO MAPA===========================================
                  
                   INSERT INTO PRODRECSUBGRU 
                      (CDFILIAL,NRMAPAPROD,CDSERVICO,CDCIA,CDSUBGRU,CDPRODREC,CDRECORIGEM,IDORIGPRODREC,
                       QTPRODREC,TXCOPRODREC,VRLOADPRODREC,CDSETORPRODREC,QTPRODRECTOT,SGUNIDADE)
                   VALUES
                      (V_CDFILIAL,V_NRMAPAPROD,V_CDSERVICO,V_CDCIA,V_CDSUBGRU,V_CDPRODREC,' ',V_ORIGEM,V_QTPRODREC,V_TXCOPRODREC,
                       V_VRLOADPRODREC,V_CDSETORPRODREC,(V_QTPRODREC*V_VRLOADPRODREC*V_QTSERV)/100,V_SGUNIDPRODREC);           
                   --==========================================================================================================
                   
                   IF V_ORIGEM = 'R' THEN --Se for uma Receita, insere os produtos da receita e as SubReceitas no mapa
                       GRAVA_PROD_SUBREC(V_CDFILIAL,V_NRMAPAPROD,V_CDCIA,V_CDSERVICO,V_CDSUBGRU,V_CDPRODREC,V_DTPRODUCAO,(V_QTPRODREC*V_VRLOADPRODREC*V_QTSERV)/100,V_CDSETORPRODREC); 
                   END IF;   
                   
                END LOOP; --Fim do Loop de Produtos/Receitas do Subgrupo
                CLOSE  C_PRODREC_SUBGRU;
                
                IF V_CONTA3 <= 0 THEN --Se o cvontador for zero,  porque no h Produto/Receita para o Sub Grupo
                    --RAISE_APPLICATION_ERROR( -20502, '?SrvSemProdRe'||V_SGCIA||'-'||V_CDARVSERVICO||'-'||V_DSSERVICO||'', false);  
                    /*  Gerao Interrompida. O Servico ||V_CDARVSERVICO||'-'||V_DSSERVICO|| Possui subgrupos sem
                        produtos/receitas associados.
                       Favor Verifique a opo "Manual Aprovado -> Manual de Custos aprovados" e tente novamente. */
                    INSERT INTO LOGMAPAPROD
                  (NRLOGMAPAPROD, CDSERVICO, DSSERVICO, CDCIA, DSCOMPANHIA, DTPRODUCAO, NRPROGSERV, DSERRO)
                  VALUES
                  (P_NRLOGMAPAPROD, V_CDSERVICO, V_DSSERVICO, V_CDCIA, V_SGCIA || ' - ' || V_NMCIA,
                   V_DTPRODUCAO, V_NRPROGSERV, 'SERVSEMPRODRE');
                END IF;
                
                
             END LOOP;--Fim do Loop de SubGrupo
             CLOSE C_SUBGRU_MAPA;
             
             IF V_CONTA2 <= 0 THEN --Se o cvontador for zero,  porque no h sub Gru. para o servio no manual da produo
                --RAISE_APPLICATION_ERROR( -20502, '?SrvSemSubGru'||V_SGCIA||'-'||V_CDARVSERVICO||'-'||V_DSSERVICO||'', false);  
                /*  Gerao Interrompida. O Servico ||V_CDARVSERVICO||'-'||V_DSSERVICO||No possui Sub Grupo associado
                    no manual da Produo vigente.
                    Favor Verifique a opo "Manual Aprovado -> Manual de Custos aprovados" e tente novamente. */
                INSERT INTO LOGMAPAPROD
                  (NRLOGMAPAPROD, CDSERVICO, DSSERVICO, CDCIA, DSCOMPANHIA, DTPRODUCAO, NRPROGSERV, DSERRO)
                  VALUES
                  (P_NRLOGMAPAPROD, V_CDSERVICO, V_DSSERVICO, V_CDCIA, V_SGCIA || ' - ' || V_NMCIA,
                   V_DTPRODUCAO, V_NRPROGSERV, 'SERVSEMSUBGRU');
             END IF;
             
                                                 
       END LOOP;--Fim do Loop de Servios do Manual
       CLOSE C_CONFIG_SERV_MANUAL;
            
       
       IF V_CONTA1 <= 0 THEN --Se o cvontador for zero,  porque no h config. para o servio no manual da produo
          
          /*SELECT CDARVPROD,NMPRODUTO 
          INTO V_CDARVSERVICO,V_DSSERVICO 
          FROM PRODUTO 
          WHERE CDPRODUTO = V_CDSERVICO; 
          
          --RAISE_APPLICATION_ERROR( -20502, '?SrvSemManual'||V_SGCIA||'-'||V_CDARVSERVICO||'-'||V_DSSERVICO||'', false);   
          /*  Gerao Interrompida. O Servico ||V_CDARVSERVICO||'-'||V_DSSERVICO||No est no Manual da Produo vigente.
              Favor Verifique a opo "Manual Aprovado -> Manual de Custos aprovados" e tente novamente. */
              
          INSERT INTO LOGMAPAPROD
                  (NRLOGMAPAPROD, CDSERVICO, DSSERVICO, CDCIA, DSCOMPANHIA, DTPRODUCAO, NRPROGSERV, DSERRO)
                  VALUES
                  (P_NRLOGMAPAPROD, V_CDSERVICO, V_DSSERVICO, V_CDCIA, V_SGCIA || ' - ' || V_NMCIA,
                   V_DTPRODUCAO, V_NRPROGSERV, 'SERVSEMMANUAL');
       END IF;
    END LOOP; --Fim do Loop dos Servios do Mapa
    CLOSE C_SERVICOS_MAPA;
    
    --========Alterar a situao das Programaes de Servio para "MAPA GERADO"==============
    UPDATE PROGSERVICO 
    SET IDSITPROGSERV = 'G'
    WHERE
       (IDSITPROGSERV = 'P' ) AND
       (CDFILIAL = P_CDFILIAL) AND
       ((P_TNRCDCIA = 'T') OR (INSTR(P_LISTACIA,CDCIA) > 0)) AND
       ((P_TNRPROGSERV = 'T') OR (INSTR(P_LISTAPROGSERV,CDCIA||'-'||NRPROGSERV) > 0));
    --========================================================================================

      
    COMMIT;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_MAPA_PROD','0.00.000'); END;
/